<?php

namespace Drupal\form_alterer\Plugin\FormAlterer;

use Drupal\Component\Utility\NestedArray;
use Drupal\Core\Form\FormStateInterface;

/**
 * The default form_alterer plugin class for yaml plugins with static overrides.
 */
class FormAltererDefault extends FormAltererPluginBase {

  /**
   * {@inheritDoc}
   */
  public function alterForm(&$form, FormStateInterface $form_state, $form_id) {
    if (!empty($this->getGlobalStaticOverrides())) {
      $form = NestedArray::mergeDeep(
        $form,
        $this->getGlobalStaticOverrides(),
      );
    }
    if (!empty($this->getSpecificStaticOverrides())) {
      foreach ($this->getSpecificStaticOverrides() as $this_form_id => $overrides) {
        if ($form_id !== $this_form_id) {
          continue;
        }
        $form = NestedArray::mergeDeep(
          $form,
          $overrides,
        );
      }
    }
    if (!isset($form['#cache'])) {
      $form['#cache'] = [];
    }
    if (!in_array('form_alterer_plugins', $form['#cache'])) {
      $form['#cache'][] = 'form_alterer_plugins';
    }
    $this->configuration['has_executed'] = TRUE;
  }

}
