<?php

declare(strict_types=1);

namespace Drupal\form_alterer\Services;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Component\Plugin\PluginManagerInterface;

/**
 * FormAlterer plugin manager interface.
 */
interface FormAltererPluginManagerInterface extends PluginManagerInterface {

  /**
   * Returns plugin instances based on the form id given.
   */
  public function getInstancesFromFormId($form_id): array;

  /**
   * Alters the given forms with form_alterer plugins.
   */
  public function alterForm(&$form, FormStateInterface $form_state, $form_id);

}
